<?xml version="1.0" encoding="UTF-8" standalone="no"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml"><head><meta http-equiv="Content-Type" content="text/html; charset=UTF-8" /><title>The Type Analysis Module</title><link rel="stylesheet" href="synopsis.css" type="text/css" /><meta name="generator" content="DocBook XSL Stylesheets V1.73.2" /><link rel="start" href="index.html" title="Synopsis Developer's Guide" /><link rel="up" href="cxx.html" title="Chapter 3. The C++ API" /><link rel="prev" href="symbol-table.html" title="The Symbol Table Module" /><link rel="next" href="cxx-tests.html" title="C++ Regression Tests" /></head><body><div class="navheader"><table width="100%" summary="Navigation header"><tr><th colspan="3" align="center">The Type Analysis Module</th></tr><tr><td width="20%" align="left"><a accesskey="p" href="symbol-table.html">Prev</a> </td><th width="60%" align="center">Chapter 3. The C++ API</th><td width="20%" align="right"> <a accesskey="n" href="cxx-tests.html">Next</a></td></tr></table></div><div class="section" lang="en" xml:lang="en"><div class="titlepage"><div><div><h2 class="title" style="clear: both"><a id="type-analysis"></a>The Type Analysis Module</h2></div></div></div><p>
        Type analysis is required to a limitted degree during parsing, as well 
        as during semantic analysis that may follow. During <span class="emphasis"><em>overload resolution</em></span>
        type analysis is needed to find the best conversion (standard or user defined), and for
        partial template specialization it is needed to match certain types for which a template
        has to be instantiated.
      </p><p>
        The type system consists of trees composed of <span class="type">Type</span> nodes which may be looked
        up in terms of their encoded names (see <a class="xref" href="ptree.html#encoding" title="The Encoding class">the section called “The Encoding class”</a>) in a
        <span class="type">TypeRepository</span>.
      </p><div class="section" lang="en" xml:lang="en"><div class="titlepage"><div><div><h3 class="title"><a id="type-repository"></a>The Type Repository</h3></div></div></div></div><div class="section" lang="en" xml:lang="en"><div class="titlepage"><div><div><h3 class="title"><a id="overload-resolution"></a>Overload Resolution</h3></div></div></div></div><div class="section" lang="en" xml:lang="en"><div class="titlepage"><div><div><h3 class="title"><a id="template-repository"></a>The Template Repository</h3></div></div></div></div><div class="section" lang="en" xml:lang="en"><div class="titlepage"><div><div><h3 class="title"><a id="type-evaluation"></a>Type Evaluation</h3></div></div></div></div><div class="section" lang="en" xml:lang="en"><div class="titlepage"><div><div><h3 class="title"><a id="const-evaluation"></a>Constant expressions</h3></div></div></div></div></div><div class="navfooter"><table width="100%" summary="Navigation footer"><tr><td width="40%" align="left"><a accesskey="p" href="symbol-table.html">Prev</a> </td><td width="20%" align="center"><a accesskey="u" href="cxx.html">Up</a></td><td width="40%" align="right"> <a accesskey="n" href="cxx-tests.html">Next</a></td></tr><tr><td width="40%" align="left" valign="top">The Symbol Table Module </td><td width="20%" align="center"><a accesskey="h" href="index.html">Home</a></td><td width="40%" align="right" valign="top"> C++ Regression Tests</td></tr></table></div></body></html>
